<?php

namespace DHLExpressGlobalWS\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for docTypeRef_PackagesResultsType StructType
 * @subpackage Structs
 */
class DocTypeRef_PackagesResultsType extends AbstractStructBase
{
    /**
     * The PackageResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \DHLExpressGlobalWS\StructType\DocTypeRef_PackageResultType[]
     */
    public $PackageResult;
    /**
     * Constructor method for docTypeRef_PackagesResultsType
     * @uses DocTypeRef_PackagesResultsType::setPackageResult()
     * @param \DHLExpressGlobalWS\StructType\DocTypeRef_PackageResultType[] $packageResult
     */
    public function __construct(array $packageResult = array())
    {
        $this
            ->setPackageResult($packageResult);
    }
    /**
     * Get PackageResult value
     * @return \DHLExpressGlobalWS\StructType\DocTypeRef_PackageResultType[]|null
     */
    public function getPackageResult()
    {
        return $this->PackageResult;
    }
    /**
     * This method is responsible for validating the values passed to the setPackageResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPackageResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePackageResultForArrayConstraintsFromSetPackageResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $docTypeRef_PackagesResultsTypePackageResultItem) {
            // validation for constraint: itemType
            if (!$docTypeRef_PackagesResultsTypePackageResultItem instanceof \DHLExpressGlobalWS\StructType\DocTypeRef_PackageResultType) {
                $invalidValues[] = is_object($docTypeRef_PackagesResultsTypePackageResultItem) ? get_class($docTypeRef_PackagesResultsTypePackageResultItem) : sprintf('%s(%s)', gettype($docTypeRef_PackagesResultsTypePackageResultItem), var_export($docTypeRef_PackagesResultsTypePackageResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PackageResult property can only contain items of type \DHLExpressGlobalWS\StructType\DocTypeRef_PackageResultType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PackageResult value
     * @throws \InvalidArgumentException
     * @param \DHLExpressGlobalWS\StructType\DocTypeRef_PackageResultType[] $packageResult
     * @return \DHLExpressGlobalWS\StructType\DocTypeRef_PackagesResultsType
     */
    public function setPackageResult(array $packageResult = array())
    {
        // validation for constraint: array
        if ('' !== ($packageResultArrayErrorMessage = self::validatePackageResultForArrayConstraintsFromSetPackageResult($packageResult))) {
            throw new \InvalidArgumentException($packageResultArrayErrorMessage, __LINE__);
        }
        $this->PackageResult = $packageResult;
        return $this;
    }
    /**
     * Add item to PackageResult value
     * @throws \InvalidArgumentException
     * @param \DHLExpressGlobalWS\StructType\DocTypeRef_PackageResultType $item
     * @return \DHLExpressGlobalWS\StructType\DocTypeRef_PackagesResultsType
     */
    public function addToPackageResult(\DHLExpressGlobalWS\StructType\DocTypeRef_PackageResultType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \DHLExpressGlobalWS\StructType\DocTypeRef_PackageResultType) {
            throw new \InvalidArgumentException(sprintf('The PackageResult property can only contain items of type \DHLExpressGlobalWS\StructType\DocTypeRef_PackageResultType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PackageResult[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \DHLExpressGlobalWS\StructType\DocTypeRef_PackagesResultsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
