<?php

namespace DHLExpressGlobalWS\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for docTypeRef_RateResponseType StructType
 * @subpackage Structs
 */
class DocTypeRef_RateResponseType extends AbstractStructBase
{
    /**
     * The Provider
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \DHLExpressGlobalWS\StructType\DocTypeRef_ProviderType[]
     */
    public $Provider;
    /**
     * Constructor method for docTypeRef_RateResponseType
     * @uses DocTypeRef_RateResponseType::setProvider()
     * @param \DHLExpressGlobalWS\StructType\DocTypeRef_ProviderType[] $provider
     */
    public function __construct(array $provider = array())
    {
        $this
            ->setProvider($provider);
    }
    /**
     * Get Provider value
     * @return \DHLExpressGlobalWS\StructType\DocTypeRef_ProviderType[]|null
     */
    public function getProvider()
    {
        return $this->Provider;
    }
    /**
     * This method is responsible for validating the values passed to the setProvider method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProvider method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProviderForArrayConstraintsFromSetProvider(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $docTypeRef_RateResponseTypeProviderItem) {
            // validation for constraint: itemType
            if (!$docTypeRef_RateResponseTypeProviderItem instanceof \DHLExpressGlobalWS\StructType\DocTypeRef_ProviderType) {
                $invalidValues[] = is_object($docTypeRef_RateResponseTypeProviderItem) ? get_class($docTypeRef_RateResponseTypeProviderItem) : sprintf('%s(%s)', gettype($docTypeRef_RateResponseTypeProviderItem), var_export($docTypeRef_RateResponseTypeProviderItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Provider property can only contain items of type \DHLExpressGlobalWS\StructType\DocTypeRef_ProviderType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Provider value
     * @throws \InvalidArgumentException
     * @param \DHLExpressGlobalWS\StructType\DocTypeRef_ProviderType[] $provider
     * @return \DHLExpressGlobalWS\StructType\DocTypeRef_RateResponseType
     */
    public function setProvider(array $provider = array())
    {
        // validation for constraint: array
        if ('' !== ($providerArrayErrorMessage = self::validateProviderForArrayConstraintsFromSetProvider($provider))) {
            throw new \InvalidArgumentException($providerArrayErrorMessage, __LINE__);
        }
        $this->Provider = $provider;
        return $this;
    }
    /**
     * Add item to Provider value
     * @throws \InvalidArgumentException
     * @param \DHLExpressGlobalWS\StructType\DocTypeRef_ProviderType $item
     * @return \DHLExpressGlobalWS\StructType\DocTypeRef_RateResponseType
     */
    public function addToProvider(\DHLExpressGlobalWS\StructType\DocTypeRef_ProviderType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \DHLExpressGlobalWS\StructType\DocTypeRef_ProviderType) {
            throw new \InvalidArgumentException(sprintf('The Provider property can only contain items of type \DHLExpressGlobalWS\StructType\DocTypeRef_ProviderType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Provider[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \DHLExpressGlobalWS\StructType\DocTypeRef_RateResponseType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
